<?php

  $debug_start = microtime(TRUE);

	session_start();

	define('VALID_RUN', true);

  // Если разрешено, загружаем и включаем функции отладки
  $debug_cgf = require_once 'system/config/debug.php';
  if (DEBUG_ON) {
    include_once 'system/core/debugconfig.php';
    include_once 'system/core/debug.php';
    cmsDebug::getInstance($debug_cgf, $debug_start);
  }

	// Устанавливаем кодировку
	header("Content-type:text/html; charset=utf-8");
    header('X-Powered-By: InstantCMS');

    require_once "bootstrap.php";

  if (DEBUG_ON) { usleep(cmsDebugConfig::getInstance()->emulate_lag * 1000); }

    // Инициализируем шаблонизатор
    $template = cmsTemplate::getInstance();

    if (href_to('auth', 'login') != $_SERVER['REQUEST_URI']){
        if (!cmsConfig::get('is_site_on') && !cmsUser::isAdmin()) {
            cmsCore::errorMaintenance();
        }
    }

    // Запускаем кеш
    cmsCache::getInstance()->start();

    cmsEventsManager::hook('engine_start');

    //Запускаем роутинг и контроллер
    $core->route($_SERVER['REQUEST_URI']);
	$core->runController();
    $core->runWidgets();

    //Выводим готовую страницу
    $template->renderPage();

    cmsEventsManager::hook('engine_stop');

    // Останавливаем кеш
    cmsCache::getInstance()->stop();

  // Если разрешено, выводим информацию отладки
  if (DEBUG_ON && cmsDebug::getInstance()->allowShow()) echo cmsDebug::getInstance()->getHtmlFull();


	// =============================================================================
	/**
	* Функция для упрощения вызовов контрольных точек при отладке
	* Без неё вызов КТ осуществляется через условие:
	* if (DEBUG_ON) cmsDebug::getInstance()->checkPoint("NAME","param=".$param, 5, true, true);
	* Входные параметры те же, что и у функции cmsDebug->checkPoint()
	* Все параметры необязательные
	* @param string $name Название точки, выводится в лог в кавычках после "CheckPoint"
	* @param string $params Строка параметров для лога, выводится без изменений
	* @param int $trace_level Глубина трассировки вызовов, 0 - выключить, -1 - по умолчанию из конфига
	* @param bool $sql_debug Временно включить показ SQL с этой контрольной точки
	* @param bool $include_debug Временно включить показ инклудов с этой контрольной точки
	*/
	function DebugCheckPoint($name="", $params="", $trace_level=-1, $sql_debug = FALSE, $include_debug = FALSE) {
		if (DEBUG_ON) cmsDebug::getInstance()->checkPoint($name, $params, $trace_level, $sql_debug, $include_debug);
	}
