<?php

class actionAdminSettingsDebug extends cmsAction {

    public function run(){
        $config = cmsDebugConfig::getInstance();

        $values = $config->getAll();

        $values['debug_on'] = DEBUG_ON;

        $form = $this->getForm('debug');

        $is_submitted = $this->request->has('submit');

        if ($is_submitted){
            $values = array_merge($values, $form->parse($this->request, $is_submitted));
            $errors = $form->validate($this,  $values);

            if (!$errors){

                $result = $config->save($values);

                if (!$result){
                    $errors = array();
                    cmsUser::addSessionMessage(LANG_CP_SETTINGS_DEBUG_NOT_WRITABLE, 'error');
                } else {
                    cmsUser::addSessionMessage(LANG_CP_SETTINGS_DEBUG_SAVED, 'success');
                }

            } else {

                cmsUser::addSessionMessage(LANG_FORM_ERRORS, 'error');

            }

				}

        return cmsTemplate::getInstance()->render('settings_debug', array(
            'values' => $values,
            'form' => $form,
            'errors' => isset($errors) ? $errors : false
        ));

    }

}
