<?php

if(!defined('VALID_RUN')) { die('ACCESS DENIED'); }

class cmsDebugConfig {

	private static $instance;

	private $data = array();	//     

	//----------------------------------------------------------------------------
	//  
	private $cfg_default = array(
		'debug_admin_only'		=> 1,	// bool     

		'debug_on_point'			=> 1,	// bool    
		'debug_on_sql'				=> 0,	// bool       
		'debug_on_auto'				=> 0,	// bool   
		'debug_on_include'		=> 0,	// bool   
		'debug_on_cache'			=> 0,	// bool     

		'trace_level_point'		=> 3,	// int      
		'trace_level_sql'			=> 3,	// int         
		'trace_level_auto'		=> 3,	// int     
		'trace_level_include'	=> 3,	// int     
		'trace_level_cache'		=> 3,	// int       

		'filter_query_sql'	=> '',	// string    SQL-    
		'filter_query_from'	=> '',	// string    SQL-  /    /
		
		'filter_include_file'	=> '',	// string      /  
		'filter_include_from'	=> '',	// string      /    /

		'includes_table_error'=> 1,	// bool       2     
		'memory_real_usage'		=> 0,	// bool   ()   
		'emulate_lag'					=> 0,	// int     ( )
	);

// =============================================================================

	public function __construct($params="") {
		if (is_array($params)) {
			$this->data = array_merge($this->cfg_default, $params);
		} else {
			define("DEBUG_CONFIG",  1); //     
			$this->data = require("system/config/debug.php");
		}
	}

	// ---------------------------------------------------------------------------

	public static function getInstance($params="") {
		if (self::$instance === null) { self::$instance = new self($params); }
		return self::$instance;
	}

	// ---------------------------------------------------------------------------

	public function set($key, $value){
		$this->data[$key] = $value;
	}

	public function __get($name) {
		return $this->data[$name];
	}

	public static function get($key){
		return self::getInstance()->$key;
	}

	public function getAll(){
		return $this->data;
	}

//==============================================================================

	/**
	*       
	* @param array $params    
	* @return int       ,  FALSE   
	*/
	public function save($params){

		$debug_on = DEBUG_ON;
		
		//        (   )
		if (array_key_exists('debug_on', $params)) {
			$debug_on = $params['debug_on'];
			unset($params['debug_on']);
		}
		
		$params = array_merge($this->cfg_default, $params);

		$dump = "<?php\n" .
				"if (!defined(\"DEBUG_ON\")) define(\"DEBUG_ON\", '" . $debug_on . "');\n\n" .
				"if (!DEBUG_ON && !defined(\"DEBUG_CONFIG\")) { return false; }\n\n" . 
				"return array(\n\n";

		foreach($params as $key=>$value){

			if (!is_numeric($value)) { $value = "'{$value}'"; }

			$tabs = 7 - ceil((mb_strlen($key)+3)/4);

			$dump .= "\t'{$key}'";
			$dump .= str_repeat("\t", $tabs);
			$dump .= "=> $value,\n";

		}

		$dump .= "\n);\n?>\n";

		$file = cmsConfig::getInstance()->root_path."system/config/debug.php";

		return @file_put_contents($file, $dump);

	}

}
